﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Collections.ObjectModel;
using Telerik.Windows;
using Telerik.Windows.Controls.DragDrop;
using System.Diagnostics;
using Telerik.Windows.Controls;

namespace TreeFileFolder
{
    public partial class MainPage : UserControl
    {
        public MainPage()
        {
            InitializeComponent();
            LoadTreeData();
            this.Tree.AddHandler(RadDragAndDropManager.DragQueryEvent, new EventHandler<DragDropQueryEventArgs>(OnDragQuery),true);
            this.Tree.AddHandler(RadDragAndDropManager.DragInfoEvent, new EventHandler<DragDropEventArgs>(OnDragInfo),true);
        }
        // OnDragQuery event handler
        private void OnDragQuery(object sender, DragDropQueryEventArgs e)
        {
            if (e.Options.Destination != null)
            {
                RadTreeViewItem targetContainer = e.Options.Destination as RadTreeViewItem;
                if ((targetContainer.Item as Entry).Name.StartsWith("Folder"))
                {
                    e.QueryResult = false;
                }
            }
        }

        // OnDragInfo event handler
        private void OnDragInfo(object sender, DragDropEventArgs e)
        {
        }

        private void LoadTreeData()
        {
            ObservableCollection<Entry> rootCollection = new ObservableCollection<Entry>();
            for (int i = 0; i < 5; i++)
            {
                Entry folder = new Entry()
                {
                    Name = "Folder" + i,
                    Description = "Description" + i,
                    IsDirectory = true,
                    PathToFile = "C:\\Folder" + i
                };
                for (int k = 0; k < 4; k++)
                {
                    Entry childFolder = new Entry()
                    {
                        Name = "ChildFolder" + k,
                        Description = "ChildFolder" + k,
                        IsDirectory = true,
                        PathToFile = "C:\\Folder\\ChildFolder" + k
                    };
                    for (int ii = 0; ii < 2; ii++)
                    {
                        Entry GrandChildFolder = new Entry()
                        {
                            Name = "ChildFolder" + ii,
                            Description = "ChildFolder" + ii,
                            IsDirectory = true,
                            PathToFile = "C:\\Folder\\ChildFolder\\GrandChild" + ii
                        };
                        childFolder.Entries.Add(GrandChildFolder);
                    }
                    for (int jj = 0; jj < 2; jj++)
                    {
                        Entry GrandChildFile = new Entry()
                        {
                            Name = "GrandChildFile" + jj,
                            Description = "Description" + jj,
                            PathToFile = "C:\\Folder\\ChildFolder\\GrandChildFile" + jj,
                            IsDirectory = false
                        };
                        childFolder.Entries.Add(GrandChildFile);
                    }
                    folder.Entries.Add(childFolder);
                }
                for (int s = 0; s < 2; s++)
                {
                    Entry ChildFile = new Entry()
                    {
                        Name = "ChildFile" + s,
                        Description = "Description" + s,
                        PathToFile = "C:\\Folder\\ChildFile" + s,
                        IsDirectory = false
                    };
                    folder.Entries.Add(ChildFile);
                }
                rootCollection.Add(folder);
            }
            for (int j = 0; j < 3; j++)
            {
                Entry file = new Entry()
                {
                    Name = "File" + j,
                    Description = "Description" + j,
                    PathToFile = "C:\\File" + j,
                    IsDirectory = false
                };
                rootCollection.Add(file);
            }

            this.Tree.ItemsSource = rootCollection;
        }
    }
}
